/*

*************************************************************************

ArmageTron -- Just another Tron Lightcycle Game in 3D.
Copyright (C) 2000  Manuel Moos (manuel@moosnet.de)

**************************************************************************

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
***************************************************************************

*/

#ifndef ArmageTron_AIBASE_H
#define ArmageTron_AIBASE_H

#include "gCycle.h"
#include "eTimer.h"

class gAIPlayer{
  tCONTROLLED_PTR(gCycle) object;
  tCHECKED_PTR(gCycle) target;
  REAL lastTime;
  REAL nextTime;

  REAL concentration;

//  gCycle * Cycle(){return object;}

public:
  gAIPlayer(gCycle *o):object(o),target(NULL),lastTime(se_GameTime()),
    nextTime(0),concentration(1){}
  ~gAIPlayer(){target=NULL; object=NULL; tCHECK_DEST;}

  void ClearTarget(){target=NULL;}
  
  // do some thinking. Return value: time to think again
  REAL Think();

  bool Alive(){
     return bool(object) && object->Alive();
  }
   
  eGameObject *Object(){return object;}
   
  void Timestep(REAL time);
};

#endif
